
(*
    This file is part of DynLoader.

    DynLoader - cross-platform dynamic module loader.
    Author: Romiras (Feb, 2010)
    License: GPL v2 license
*)

{$IFDEF FPC}
    {$mode delphi}
{$ENDIF}

Unit DynLoader;

Interface

Type

    TModuleName = PChar;
    TSymbolName = PChar;
    TModuleDataSize = Cardinal;

    TDynLoadModuleBase = class
        function LoadModule (FileName: TModuleName): Boolean; Virtual; Abstract;
        function LoadModuleEx (FileName: TModuleName; Flags: Cardinal): Boolean; Virtual; Abstract;
        procedure UnloadModule; Virtual; Abstract;
        function GetModuleSymbol (SymbolName: TSymbolName): Pointer; Virtual; Abstract;
        function GetModuleSymbolEx (SymbolName: TSymbolName; var Accu: Boolean): Pointer; Virtual; Abstract;
        function ReadModuleData (SymbolName: TSymbolName; var Buffer; Size: TModuleDataSize): Boolean;
        function WriteModuleData (SymbolName: TSymbolName; var Buffer; Size: TModuleDataSize): Boolean;
    end;

Implementation

function TDynLoadModuleBase.ReadModuleData (SymbolName: TSymbolName; var Buffer; Size: TModuleDataSize): Boolean;
var
    Sym: Pointer;
begin
    Result := True;
    Sym := GetModuleSymbolEx (SymbolName, Result);
    if Result then
        Move (Sym^, Buffer, Size)
end;

function TDynLoadModuleBase.WriteModuleData (SymbolName: TSymbolName; var Buffer; Size: TModuleDataSize): Boolean;
var
    Sym: Pointer;
begin
    Result := True;
    Sym := GetModuleSymbolEx (SymbolName, Result);
    if Result then
        Move (Buffer, Sym^, Size)
end;

End.
